signature QUEUE =
sig
  type 'a queue

  exception Empty

  val empty : 'a queue
      
  val add : 'a queue -> 'a -> 'a queue

  val remove : 'a queue -> ('a * 'a queue)

  val app : 'a queue -> ('a -> unit) -> unit

  val toList : 'a queue -> 'a list
end
